// *****************************************************************
// ****			     SD and MMC memory cards driver             ****
// ****                     www.tolaemon.com                    ****
// ****                       Source code                       ****
// ****                       16-10-2008                        ****
// ****                     Jordi Bartolome                     ****
// ****                                                         ****
// **** IMPORTANT:                                              ****
// **** Using parts of this code means accepting all conditions ****
// **** exposed on the web: www.tolaemon.com/hplayer            ****
// *****************************************************************
#ifndef _SDC_
#define _SDC_

#include <inttypes.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/sleep.h>

#include "iocompat.h"

#define SDMMC_SECTOR_SIZE 512
#define SDMMC_NULL_SECTOR 1073741824;// is the last possible sector in a SD_MMC card, the maximum value in a 32 bit unsigned integer
#define INITIALIZE_RETRYS 2

typedef struct {
	uint8_t sector_buffer[SDMMC_SECTOR_SIZE];
	uint32_t actual_sector;
}t_SDMMC_buffer;

void SDMMC_Init();
void SDMMC_Test(int8_t step);
uint8_t SDMMC_wait_answer ( );
uint8_t SDMMC_send_byte(uint8_t valor);
uint8_t SDMMC_InitializeCard();
uint8_t SDMMC_ReadByte(uint32_t sector,uint16_t offset,uint8_t * read_byte);

#endif
